package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.action;
import java.io.UnsupportedEncodingException;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.lang3.StringUtils;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import com.google.common.base.Preconditions;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.service.CompanyInfoService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.utils.CompanyInfoProperties;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
/*
 * 董监高对外投资接口*/
@Slf4j
@RestController
public class CompanyInfoAction {
	@Autowired
	CompanyInfoService companyInfoService;
	private String xRresponseCode = "x-responseCode";
	private String xIsCharge = "x-isCharge";
	@Autowired
	CompanyInfoProperties property;
	@ApiOperation(value = "企业信息查询")
    @PostMapping("/companyInfo.do")
	public ChannelTypeHandleResponseObject companyInfo(@RequestHeader(value = "channelId", required = true) String channelId,
	                                                     @RequestHeader(value = "ifJkCode", required = false) String ifJkCode,
	                                                     @RequestParam(name = "outTime",required = false) Integer outTime,
	                                                     @RequestParam(name = "customBody",required = false) String customBody) {
	    Preconditions.checkArgument(StringUtils.isNotBlank(channelId),"通道id不能为空");
	    Preconditions.checkArgument(StringUtils.isNotBlank(customBody),"查询参数不能为空");
	    log.info("---------->企业信息请求：channelId：{}，ifJkCode：{},outTime：{}, customBody：{}",
	                channelId,
	                ifJkCode,
	                outTime,
	                customBody);
	    //设置返回码
	    HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
	    /**初始化设置日志记录*/
        request.setAttribute(Constant.CHANNEL_TYPE_KEY,Constant.CHANNEL_TYPE_SYNC);
        request.setAttribute(xIsCharge,Constant.IS_NOT_CHARGE);
        request.setAttribute(xRresponseCode,Constant.CHANNEL_LOG_ERROR_CODE);
        request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE);
        ChannelTypeHandleResponseObject responseObject = new ChannelTypeHandleResponseObject();
        try{
             responseObject = companyInfoService.companyInfo(request,outTime,customBody);
	         if(responseObject.getCode() != 1){
	             request.setAttribute(xRresponseCode,Constant.CHANNEL_LOG_ERROR_CODE);
	         }else{
	         	 if(Constant.CUSTOMER_RETURN_JK.equals(ifJkCode)){
	              	String code = property.getCode().get(responseObject.getResultCode());
	              	if(code!=null){
	              		responseObject.setResultCode(Integer.valueOf(code));
	              	}
	              }
	              if(property.getDesc().get(responseObject.getResultCode())!=null){
	              	responseObject.setResultDesc(property.getDesc().get(responseObject.getResultCode()));
	              }
	             request.setAttribute(xRresponseCode,Constant.CHANNEL_LOG_SUCCESS_CODE);
	         }
	         if(customBody != null){
	             try {
	                 request.setAttribute(Constant.CHANNEL_LOG_QUERY,Base64.encodeBase64String(customBody.getBytes("utf-8")));
	             } catch (UnsupportedEncodingException e) {
	                 log.error("",e);
	             }
	         }
	         request.setAttribute(xIsCharge,responseObject.getIsCharge());
         }catch(Exception  ex){
            	ErrorUtils.captureException(ex);
            	log.error("error message:{}",ex);
         }
	     return responseObject;    
	}

}
