package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.utils;

import com.alibaba.fastjson.JSONObject;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.constant.SjjhConstant;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/6/28 16:05
 * @version: V1.0
 **/
@Component
public class DecodeUtil {

    private static String decryptKey;

    private static String aesDecryptKey;

    @Value("${wz.decryptKey}")
    public void setDecryptKey(String decryptKey) {
        DecodeUtil.decryptKey = decryptKey;
    }

    @Value("${wz.aesDecryptKey}")
    public void setAesDecryptKey(String aesDecryptKey) {
        DecodeUtil.aesDecryptKey = aesDecryptKey;
    }

    public static String decodeParams(ChannelTypeHandleResponseObject ret, String returnType, String customBody) {
        JSONObject requestParamObject = JSONObject.parseObject(customBody);
        if (requestParamObject.get("params") == null) {
            if (Constant.CUSTOMER_RETURN_ZW.equals(returnType)) {
                ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
                ret.setResultBody(Constant.INVALID_PARAMETER);
                ret.setResultDesc(Constant.INVALID_PARAMETER);
            } else {
                ret.setResultCode(Constant.JK_RETURN_CODE_INVALID_PARAMETER);
                ret.setResultBody(Constant.INVALID_PARAMETER);
                ret.setResultDesc(Constant.INVALID_PARAMETER);
            }
            requestParamObject = null;
            return "";
        }

        if (requestParamObject.get("type") != null && requestParamObject.get("type").equals("1")) {
            try {
                customBody = AesUtil.decryAES(aesDecryptKey, requestParamObject.getString("params"));
                if (StringUtils.isBlank(customBody)) {
                    if (Constant.CUSTOMER_RETURN_ZW.equals(returnType)) {
                        ret.setResultCode(Constant.ZW_RETURN_CODE_133);
                    } else {
                        ret.setResultCode(Constant.JK_RETURN_CODE_9931);
                    }
                    ret.setResultBody(Constant.RETURN_MESSAGE_133);
                    ret.setResultDesc(Constant.RETURN_MESSAGE_133);
                    return "";
                }
            } catch (Exception e) {
                ErrorUtils.captureException(e);
                if (Constant.CUSTOMER_RETURN_ZW.equals(returnType)) {
                    ret.setResultCode(Constant.ZW_RETURN_CODE_133);
                } else {
                    ret.setResultCode(Constant.JK_RETURN_CODE_9931);
                }
                ret.setResultBody(Constant.RETURN_MESSAGE_133);
                ret.setResultDesc(Constant.RETURN_MESSAGE_133);
                return "";
            }
        } else {
            customBody = DESedeUtil.decryptMode(requestParamObject.getString("params"), decryptKey);
            if (StringUtils.isBlank(customBody)) {
                if (Constant.CUSTOMER_RETURN_ZW.equals(returnType)) {
                    ret.setResultCode(Constant.ZW_RETURN_CODE_133);
                    ret.setResultBody(Constant.RETURN_MESSAGE_133);
                    ret.setResultDesc(Constant.RETURN_MESSAGE_133);
                } else {
                    ret.setResultCode(Constant.JK_RETURN_CODE_9931);
                    ret.setResultBody(Constant.RETURN_MESSAGE_133);
                    ret.setResultDesc(Constant.RETURN_MESSAGE_133);
                }
            }

        }
        requestParamObject = null;
        return customBody;
    }
}
