package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.utils;

import info.aspirecn.iov.sjjh.commons.lang.Constant;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.RandomStringUtils;
import sun.misc.BASE64Encoder;

import javax.crypto.*;
import javax.crypto.spec.DESKeySpec;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.URLDecoder;
import java.security.*;
import java.security.spec.InvalidKeySpecException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Formatter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther jianggang
 * @Date 2018/10/26 09:50:03
 * @Description
 */
@Slf4j
public class Utils {

    private Utils() {
    }

    private static final String KEY = "KTDQQz4V";

    private static String encode = "UTF-8";

    public static String desEncrypt(String plaintext) throws NoSuchPaddingException,
            NoSuchAlgorithmException, UnsupportedEncodingException,
            InvalidKeySpecException, InvalidAlgorithmParameterException,
            InvalidKeyException, BadPaddingException, IllegalBlockSizeException {
        Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
        DESKeySpec desKeySpec = new DESKeySpec(KEY.getBytes(encode));
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        SecretKey secretKey = keyFactory.generateSecret(desKeySpec);
        IvParameterSpec iv = new IvParameterSpec(KEY.substring(0, 8).getBytes(encode));
        cipher.init(Cipher.ENCRYPT_MODE, secretKey, iv);
        byte[] bt = cipher.doFinal(plaintext.getBytes(encode));
        return new BASE64Encoder().encode(bt);
    }

    public static String encrypt(String key,String target) {
        Cipher cipher = null;
        byte[] bt = null;
        try {
            cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
            DESKeySpec desKeySpec = new DESKeySpec(KEY.substring(0, 8).getBytes(encode));
            SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
            SecretKey secretKey = keyFactory.generateSecret(desKeySpec);
            IvParameterSpec iv = new IvParameterSpec(key.getBytes(encode));
            cipher.init(Cipher.ENCRYPT_MODE, secretKey, iv);
            bt = cipher.doFinal(target.getBytes(encode));
        } catch (Exception e) {
            log.info("---------->DES加密失败！={}", e);
        }
        return new BASE64Encoder().encode(bt);
    }



    public static String  generateFaceCompareAuthorization(String apiKey , String apiSecret) throws SignatureException {
        String nonce = RandomStringUtils.randomAlphanumeric(16);
        String timestamp = Long.toString(System.currentTimeMillis());
        String hashAlgorithm = "HmacSHA256";

        ArrayList<String> beforesort = new ArrayList();
        beforesort.add(apiKey);
        beforesort.add(timestamp);
        beforesort.add(nonce);

        Collections.sort(beforesort, new SpellComparator());
        StringBuilder aftersort = new StringBuilder();
        for (int i = 0; i < beforesort.size(); i++) {
            aftersort.append(beforesort.get(i));
        }

        String oriString = aftersort.toString();

        try{
            Key sk = new SecretKeySpec(apiSecret.getBytes(), hashAlgorithm);
            Mac mac = Mac.getInstance(sk.getAlgorithm());
            mac.init(sk);
            final byte[] hmac = mac.doFinal(oriString.getBytes());
            StringBuilder sb = new StringBuilder(hmac.length * 2);

            try (Formatter formatter = new Formatter(sb)) {
                for (byte b : hmac) {
                    formatter.format("%02x", b);
                }
            }
            String encryptedString = sb.toString();

            return "key=" + apiKey
                    +",timestamp=" + timestamp
                    +",nonce=" + nonce
                    +",signature=" + encryptedString;

        }catch (NoSuchAlgorithmException e1){
            throw new SignatureException("error building signature, no such algorithm in device "+ hashAlgorithm);
        }catch (InvalidKeyException e){
            throw new SignatureException("error building signature, invalid key " + hashAlgorithm);
        }
    }

    public static Integer switchFaceCompareCode(Integer oldCode,String customerType){
        if(Constant.CUSTOMER_RETURN_JK.equals(customerType)){
            switch (oldCode) {
                case 1000:
                    return 1000;
                case 1200:
                    return 9909;
                case 1100:
                case 1101:
                case 1103:
                case 1002:
                case 3000:
                case 3001:
                case 3002:
                    return 9901;
                case 2003:
                    return 9902;
                case 2004:
                    return 9904;
                case 2005:
                    return 9905;
                case 2006:
                    return 9906;
                case 3003:
                    return 9907;
                case 3004:
                    return 9908;
                case 3005:
                    return 9910;
                case 4000:
                    return 9911;
                default:
            }
        }

        if(Constant.CUSTOMER_RETURN_ZW.equals(customerType)){
            switch (oldCode) {
                case 1000:
                    return 1;
                case 1200:
                    return 8;
                case 1100:
                case 1101:
                case 1103:
                case 1002:
                case 3000:
                case 3001:
                case 3002:
                    return 3;
                case 2003:
                    return Constant.INVALID_PICTURE_SIZE;
                case 2004:
                    return Constant.INVALID_CONTENT_LENGTH;
                case 2005:
                    return Constant.INVALID_PICTURE_TYPE;
                case 2006:
                    return Constant.PICTURE_BROKEN;
                case 3003:
                    return Constant.UN_MATCH_CODE;
                case 3004:
                    return Constant.UN_FIND_NUM_CODE;
                case 3005:
                    return Constant.THIRD_BASE_PIC_NOT_EXIST;
                case 4000:
                    return Constant.UN_FIND_FACE;
                default:
            }
        }

        return oldCode;


    }

    public static String switchFaceCompareFailMessage(Integer oldCode){
        switch (oldCode) {
            case 1200:
                return "参数错误或姓名、身份证号不合法";
            case 1100:
            case 1101:
            case 1103:
            case 1002:
            case 3000:
            case 3001:
            case 3002:
                return "查询错误";
            case 2003:
                return "图片大小不符合要求";
            case 2004:
                return "输入内容长度不符合要求";
            case 2005:
                return "图片类型不符合要求";
            case 2006:
                return "图片损坏";
            case 3003:
                return "姓名与身份证号不匹配";
            case 3004:
                return "身份证号无效";
            case 3005:
                return "第三方底图不存在";
            case 4000:
                return "提取特征失败,没有检测到图片中的人脸";
            default:
                return "";
        }
    }
    //计算签名
    public  static String calculateParam(Object object,String secret) {
		try {
			Class cls = object.getClass();
			Field[] fields = cls.getDeclaredFields();
			String params = "";
			StringBuffer sbf = new StringBuffer();
			for (Field field : fields) {
				String fieldName = field.getName();
				Method method = cls.getMethod("get" + fieldName.substring(0, 1).toUpperCase() + fieldName.substring(1));
				String value = (String) method.invoke(object);
				if(value!=null){
					value = URLDecoder.decode(value, "utf-8");
					sbf.append(fieldName).append("=").append(value).append("&");
				}
				
			}
			if (sbf.length() != 0) {
				sbf = sbf.delete(sbf.length() - 1, sbf.length());
				log.info("加密之前:{}",sbf);
			   params = encrypt(secret,sbf.toString());
			   log.info("加密之后:{}",params);
			}
			return params;
		} catch (Exception ex) {
			log.error("计算签名错误:{}", ex);
		}
		return "";
	}
 
    /**
     * 是否是有效的统一社会信用代码
     *
     * @param businessCode 统一社会信用代码
     * @return
     */
    public static boolean isValidSocialCreditCode(String businessCode) {
    	 if ((businessCode.equals("")) || businessCode.length() != 18) {
    		 return false; 
    	 } 
    	 String baseCode = "0123456789ABCDEFGHJKLMNPQRTUWXY"; 
    	 char[] baseCodeArray = baseCode.toCharArray(); 
    	 Map<Character, Integer> codes = new HashMap<Character, Integer>();
    	 for (int i = 0; i < baseCode.length(); i++) { 
    		 codes.put(baseCodeArray[i], i); 
         } 
    	 char[] businessCodeArray = businessCode.toCharArray(); 
    	 Character check = businessCodeArray[17]; 
    	 if (baseCode.indexOf(check) == -1) { 
    		 return false; 
    	 } 
    	 int[] wi = { 1, 3, 9, 27, 19, 26, 16, 17, 20, 29, 25, 13, 8, 24, 10, 30, 28 }; 
    	 int sum = 0; 
    	 for (int i = 0; i < 17; i++) { 
    		 Character key = businessCodeArray[i]; 
    		 if (baseCode.indexOf(key) == -1) { 
    			 return false; 
    		 } 
    		 sum += (codes.get(key) * wi[i]); 
    	 } 
    	 int value = 31 - sum % 31; 
    	 return value == codes.get(check);
    
    }

}
