package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.yh.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.ToString;

/**
 * 查询车辆运输许可证信息接口响应对象
 * @author lixinxu
 *
 */
@Data
@ToString(callSuper = true, includeFieldNames = true)
public class IdentityCardCheckResponseObject {
	/**返回码*/
	@JsonProperty("code")
	private String code;

	/**返回信息*/
	@JsonProperty("msg")
	private String msg;

	/**流水号*/
	@JsonProperty("serialno")
	private String serialno;

	/**返回的具体信息*/
	@JsonProperty("data")
	private Details data;

	@Data
	public static class Details {

		/**姓名*/
		@JsonProperty("name")
		private String name;

		/**身份证号*/
		@JsonProperty("identityCard")
		private String identityCard;

		/**返回结果码：
		 1 （一致）----收费
		 2 （不一致）----收费
		 3 （库中无此号）----不收费*/
		@JsonProperty("compStatus")
		private String compStatus;

		/**返回结果码解释：
		 一致
		 不一致
		 库中无此号*/
		@JsonProperty("compResult")
		private String compResult;

	}
}